/*!
 * bootstrap-for-vue v0.3.3
 * (c) 2017 Rahul Kadyan
 * Released under the MIT License.
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
	typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
	(factory((global['bootstrap-for-vue'] = global['bootstrap-for-vue'] || {}),global.Vue));
}(this, (function (exports,vue) { 'use strict';

vue = 'default' in vue ? vue['default'] : vue;

var tooltip = {
  bind: function bind (el, binding) {
    el.setAttribute('data-title', binding.value);

    jQuery(el).tooltip({
      animation: false,
      html: binding.modifiers.html || false,
      placement: binding.arg || 'bottom',
      trigger: 'hover'
    });
  },

  update: function update (el, binding) {
    if (binding.value !== binding.oldValue) {
      el.setAttribute('data-original-title', binding.value);
    }
  },

  unbind: function unbind (el) {
    jQuery(el).tooltip('hide').tooltip('dispose');
  }
};



var directives = Object.freeze({
	Tooltip: tooltip
});

var Alert = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"alert",class:[("alert-" + (_vm.type))],attrs:{"role":"alert"}},[_c('button',{directives:[{name:"show",rawName:"v-show",value:(_vm.dismissible),expression:"dismissible"}],staticClass:"close",attrs:{"type":"button","aria-label":"Close"},on:{"click":_vm.dismiss}},[_c('span',{attrs:{"aria-hidden":"true"}},[_vm._v("×")])]),_vm._t("default",[_vm._v(_vm._s(_vm.message))])],2)},staticRenderFns: [],
  name: 'Alert',

  props: {
    message: {
      type: String
    },

    type: {
      type: String,
      default: 'success'
    },

    dismissible: {
      type: Boolean,
      default: true
    }
  },

  methods: {
    /**
     * Dismiss alert.
     *
     * @return {undefined}
     */
    dismiss: function dismiss () {
      this.$emit('dismiss');
    }
  }
};

var Breadcrumb = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('nav',{staticClass:"breadcrumb"},_vm._l((_vm.crumbs),function(crumb){return _c(_vm.component,{tag:"div",staticClass:"breadcrumb-item",attrs:{"to":crumb.link,"active-class":"active"}},[_vm._v(_vm._s(crumb.title))])}))},staticRenderFns: [],
  props: {
    links: {
      type: Array,
      required: true
    },

    component: {
      type: String,
      default: 'router-link'
    }
  },

  computed: {
    crumbs: function crumbs () {
      var links = this.links;

      if (typeof (links[0]) === 'string') {
        return links.map(function (link) { return ({ link: link, title: link }); })
      }

      return links
    }
  }
};

var Dropdown = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{class:[("drop" + (_vm.type)), (_vm.show ? 'show' : '')]},[_vm._t("default"),(_vm.items.length)?_c('div',{staticClass:"dropdown-menu"},[_vm._t("items",_vm._l((_vm.items),function(item,index){return _c(_vm.component,_vm._b({key:item,tag:"div",staticClass:"dropdown-item",class:{ active: _vm.active === index },attrs:{"role":"button"},on:{"click":function($event){$event.preventDefault();_vm.$emit('select', item);}},nativeOn:{"click":function($event){$event.preventDefault();_vm.$emit('select', item);}}},'div',{ active: _vm.active === index, selected: _vm.selected.indexOf(item) > -1, item: item}),[_vm._v(_vm._s(item[_vm.itemKey]))])}))],2):_c('div',{staticClass:"dropdown-menu"},[_vm._t("empty")],2)],2)},staticRenderFns: [],
  props: {
    show: {
      type: Boolean,
      required: true
    },

    active: {},

    selected: {
      type: Array,
      default: function () { return []; }
    },

    type: {
      validator: function validator (type) {
        return ['up', 'down'].indexOf(type) > -1
      },
      default: 'down'
    },

    items: {
      type: Array,
      default: function () { return []; }
    },

    itemKey: {
      type: String,
      default: 'name'
    },

    component: {
      type: String,
      default: 'div'
    }
  }
};

var Icon = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('i',{staticClass:"fa",class:[_vm.typeName]})},staticRenderFns: [],
  name: 'Icon',

  props: {
    type: {
      required: true,
      type: String
    }
  },

  computed: {
    typeName: function typeName () {
      return ("fa-" + (this.type))
    }
  }
};

var CustomModal = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.showing)?_c('div',{staticClass:"bootstrap-for-vue-CustomModal-custom-modal",attrs:{"tabindex":"1"},on:{"keydown":function($event){if(_vm._k($event.keyCode,"esc",27)){ return; }$event.stopPropagation();_vm.$emit('close');}}},[_c('div',{staticClass:"bootstrap-for-vue-CustomModal-backdrop"}),_c('div',{ref:"wrapper",staticClass:"bootstrap-for-vue-CustomModal-wrapper",class:[_vm.wrapper || _vm.$style.wrapperDefault ],on:{"click":function($event){$event.stopPropagation();_vm.onWrapper($event);}}},[_vm._t("default")],2),(_vm.dismissable)?_c('a',{staticClass:"bootstrap-for-vue-CustomModal-dismiss",attrs:{"role":"button"},on:{"click":function($event){$event.preventDefault();_vm.$emit('close');}}},[_vm._v("×")]):_vm._e()]):_vm._e()},staticRenderFns: [],cssModules: {"customModal":"bootstrap-for-vue-CustomModal-custom-modal","custom-modal":"bootstrap-for-vue-CustomModal-custom-modal","backdrop":"bootstrap-for-vue-CustomModal-backdrop","inverse":"bootstrap-for-vue-CustomModal-inverse","dismiss":"bootstrap-for-vue-CustomModal-dismiss","wrapper":"bootstrap-for-vue-CustomModal-wrapper","wrapperDefault":"bootstrap-for-vue-CustomModal-wrapper-default","wrapper-default":"bootstrap-for-vue-CustomModal-wrapper-default"},
  name: 'Modal',

  props: {
    open: {
      default: null,
      type: Boolean
    },
    dismissOnBackdrop: {
      default: true,
      type: Boolean
    },
    wrapper: {
      type: String
    },
    dismissable: {
      type: Boolean,
      default: true
    }
  },

  data: function data () {
    return { state: false }
  },

  computed: {
    $style: function $style () {
      return this.$options.cssModules
    },

    showing: function showing () {
      var open = this.open;
      var state = this.state;

      if (open !== null) {
        return open
      }

      return state
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('open', function () {
      this$1.state = true;
    });

    this.$on('close', function () {
      this$1.state = false;
    });
  },
  methods: {
    onWrapper: function onWrapper (event) {
      if (!this.dismissable) { return }

      if (this.dismissOnBackdrop && this.$refs.wrapper === event.target) {
        this.$emit('close');
      }
    }
  },

  watch: {
    showing: function showing (state) {
      if (state) {
        document.body.classList.add('modal-open');
      } else {
        document.body.classList.remove('modal-open');
      }
    }
  }
};

var BootstrapModal = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.inDOM)?_c('div',{staticClass:"modal"},[_c('div',{staticClass:"modal-dialog",class:( obj = {}, obj[("modal-" + (_vm.size))] = _vm.size !== undefined, obj ),attrs:{"role":"document"}},[_c('div',{staticClass:"modal-content"},[(_vm.enableHeader)?_c('div',{staticClass:"modal-header"},[_vm._t("header",[_c('h5',{staticClass:"modal-title"},[_vm._t("title",[_vm._v(_vm._s(_vm.title))])],2)]),_c('button',{staticClass:"close",attrs:{"type":"button","aria-label":"Close"},on:{"click":function($event){_vm.$emit('close');}}},[_c('span',{attrs:{"aria-hidden":"true"}},[_vm._v("×")])])],2):_vm._e(),_c('div',{staticClass:"modal-body"},[_vm._t("default")],2),(_vm.enableFooter)?_c('div',{staticClass:"modal-footer"},[_vm._t("footer")],2):_vm._e()])])]):_vm._e()
var obj;},staticRenderFns: [],
  props: {
    enableFooter: {
      type: Boolean,
      default: false
    },

    enableHeader: {
      type: Boolean,
      default: true
    },

    title: {
      type: String
    },

    size: {
      type: String
    },

    open: {
      type: Boolean,
      default: null
    }
  },

  data: function data () {
    return { state: false, inDOM: false, selector: null }
  },

  computed: {
    shown: function shown () {
      var open = this.open;
      var state = this.state;

      if (open !== null) { return open }

      return state
    }
  },

  methods: {
    onShow: function onShow () {
      var this$1 = this;

      this.inDOM = true;

      this.$nextTick(function () { return this$1.showModal(); });
    },

    showModal: function showModal () {
      var this$1 = this;

      this.selector = jQuery(this.$el);
      this.selector.modal();
      this.selector.on('hidden.bs.modal', function () {
        this$1.inDOM = false;
        this$1.selector = null;
      });
    },

    onHide: function onHide () {
      if (this.selector) { this.selector.modal('hide'); }
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('show', function () { return this$1.onShow(); });
    this.$on('hide', function () { return this$1.onHide(); });
  },

  watch: {
    open: function open (shown) {
      if (shown === true) {
        this.onShow();
      } else if (shown === false) {
        this.onHide();
      }
    }
  }
};

var Modal = {
  functional: true,

  render: function render (h, ref) {
    var props = ref.props;
    var data = ref.data;
    var children = ref.children;

    if (props.custom) { return h(CustomModal, data, children) }

    return h(BootstrapModal, data, children)
  },

  props: {
    custom: {
      type: Boolean,
      default: false
    }
  }
};

var SearchField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-control bootstrap-for-vue-Search-input-search"},[(_vm.isEmpty)?_c('div',{staticClass:"bootstrap-for-vue-Search-input-search-placeholder"},[(_vm.icon)?_c('icon',{staticClass:"mr-1",attrs:{"type":_vm.icon}}):_vm._e(),_c('input',{staticClass:"input-search-proxy",attrs:{"type":"text","readonly":"","tabindex":"-1"},domProps:{"value":_vm.placeholder}})],1):_vm._e(),(!_vm.isEmpty && _vm.hasSuggestion && _vm.show)?_c('input',{staticClass:"bootstrap-for-vue-Search-input-search-suggestion",attrs:{"type":"text","readonly":"","tabindex":"-1"},domProps:{"value":_vm.suggestion}}):_vm._e(),_vm._v(" "),_c('input',_vm._b({staticClass:"bootstrap-for-vue-Search-input-search-field",attrs:{"type":"search"},on:{"keydown":function (e) { return _vm.$emit('keydown', e); },"keyup":function (e) { return _vm.$emit('keyup', e); },"keypress":function (e) { return _vm.$emit('keypress', e); },"input":function($event){_vm.$emit('input', $event.target.value);},"focus":_vm.onFocus,"blur":_vm.onBlur}},'input',{ autofocus: _vm.autofocus, autocomplete: _vm.autocomplete, value: _vm.value }))])},staticRenderFns: [],cssModules: {"inputSearch":"bootstrap-for-vue-Search-input-search","input-search":"bootstrap-for-vue-Search-input-search","inputSearchPlaceholder":"bootstrap-for-vue-Search-input-search-placeholder","input-search-placeholder":"bootstrap-for-vue-Search-input-search-placeholder","inputSearchSuggestion":"bootstrap-for-vue-Search-input-search-suggestion","input-search-suggestion":"bootstrap-for-vue-Search-input-search-suggestion","inputSearchField":"bootstrap-for-vue-Search-input-search-field","input-search-field":"bootstrap-for-vue-Search-input-search-field"},
  name: 'Search',

  props: {
    suggestion: {
      type: String
    },
    placeholder: {
      type: String,
      default: 'Search...'
    },
    value: {
      type: String,
      required: true
    },
    icon: {
      type: [String, Boolean],
      default: 'search'
    },
    autofocus: [Boolean],
    autocomplete: [String, Boolean]
  },

  data: function data () {
    return { show: false }
  },

  computed: {
    /**
     * Whether suggestion is available or not?
     *
     * @type {Boolean}
     */
    hasSuggestion: function hasSuggestion () {
      var suggestion = this.suggestion;

      return typeof (suggestion) === 'string' && suggestion.length > 0
    },

    /**
     * Whether input field is empty or not?
     *
     * @type {Boolean}
     */
    isEmpty: function isEmpty () {
      var value = this.value;

      return typeof (value) === 'string' && value.length === 0
    }
  },

  methods: {
    onBlur: function onBlur (event) {
      this.show = false;

      this.$emit('blur', event);
    },
    onFocus: function onFocus (event) {
      this.show = true;

      this.$emit('focus', event);
    }
  },

  components: { Icon: Icon }
};

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};





function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var sifter = createCommonjsModule(function (module, exports) {
/**
 * sifter.js
 * Copyright (c) 2013 Brian Reavis & contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the License at:
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
 * ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 *
 * @author Brian Reavis <brian@thirdroute.com>
 */

(function(root, factory) {
	if (typeof undefined === 'function' && undefined.amd) {
		undefined(factory);
	} else {
		module.exports = factory();
	}
}(commonjsGlobal, function() {

	/**
	 * Textually searches arrays and hashes of objects
	 * by property (or multiple properties). Designed
	 * specifically for autocomplete.
	 *
	 * @constructor
	 * @param {array|object} items
	 * @param {object} items
	 */
	var Sifter = function(items, settings) {
		this.items = items;
		this.settings = settings || {diacritics: true};
	};

	/**
	 * Splits a search string into an array of individual
	 * regexps to be used to match results.
	 *
	 * @param {string} query
	 * @returns {array}
	 */
	Sifter.prototype.tokenize = function(query) {
		var this$1 = this;

		query = trim(String(query || '').toLowerCase());
		if (!query || !query.length) { return []; }

		var i, n, regex, letter;
		var tokens = [];
		var words = query.split(/ +/);

		for (i = 0, n = words.length; i < n; i++) {
			regex = escape_regex(words[i]);
			if (this$1.settings.diacritics) {
				for (letter in DIACRITICS) {
					if (DIACRITICS.hasOwnProperty(letter)) {
						regex = regex.replace(new RegExp(letter, 'g'), DIACRITICS[letter]);
					}
				}
			}
			tokens.push({
				string : words[i],
				regex  : new RegExp(regex, 'i')
			});
		}

		return tokens;
	};

	/**
	 * Iterates over arrays and hashes.
	 *
	 * ```
	 * this.iterator(this.items, function(item, id) {
	 *    // invoked for each item
	 * });
	 * ```
	 *
	 * @param {array|object} object
	 */
	Sifter.prototype.iterator = function(object, callback) {
		var iterator;
		if (is_array(object)) {
			iterator = Array.prototype.forEach || function(callback) {
				var this$1 = this;

				for (var i = 0, n = this.length; i < n; i++) {
					callback(this$1[i], i, this$1);
				}
			};
		} else {
			iterator = function(callback) {
				var this$1 = this;

				for (var key in this$1) {
					if (this$1.hasOwnProperty(key)) {
						callback(this$1[key], key, this$1);
					}
				}
			};
		}

		iterator.apply(object, [callback]);
	};

	/**
	 * Returns a function to be used to score individual results.
	 *
	 * Good matches will have a higher score than poor matches.
	 * If an item is not a match, 0 will be returned by the function.
	 *
	 * @param {object|string} search
	 * @param {object} options (optional)
	 * @returns {function}
	 */
	Sifter.prototype.getScoreFunction = function(search, options) {
		var self, fields, tokens, token_count, nesting;

		self        = this;
		search      = self.prepareSearch(search, options);
		tokens      = search.tokens;
		fields      = search.options.fields;
		token_count = tokens.length;
		nesting     = search.options.nesting;

		/**
		 * Calculates how close of a match the
		 * given value is against a search token.
		 *
		 * @param {mixed} value
		 * @param {object} token
		 * @return {number}
		 */
		var scoreValue = function(value, token) {
			var score, pos;

			if (!value) { return 0; }
			value = String(value || '');
			pos = value.search(token.regex);
			if (pos === -1) { return 0; }
			score = token.string.length / value.length;
			if (pos === 0) { score += 0.5; }
			return score;
		};

		/**
		 * Calculates the score of an object
		 * against the search query.
		 *
		 * @param {object} token
		 * @param {object} data
		 * @return {number}
		 */
		var scoreObject = (function() {
			var field_count = fields.length;
			if (!field_count) {
				return function() { return 0; };
			}
			if (field_count === 1) {
				return function(token, data) {
					return scoreValue(getattr(data, fields[0], nesting), token);
				};
			}
			return function(token, data) {
				for (var i = 0, sum = 0; i < field_count; i++) {
					sum += scoreValue(getattr(data, fields[i], nesting), token);
				}
				return sum / field_count;
			};
		})();

		if (!token_count) {
			return function() { return 0; };
		}
		if (token_count === 1) {
			return function(data) {
				return scoreObject(tokens[0], data);
			};
		}

		if (search.options.conjunction === 'and') {
			return function(data) {
				var score;
				for (var i = 0, sum = 0; i < token_count; i++) {
					score = scoreObject(tokens[i], data);
					if (score <= 0) { return 0; }
					sum += score;
				}
				return sum / token_count;
			};
		} else {
			return function(data) {
				for (var i = 0, sum = 0; i < token_count; i++) {
					sum += scoreObject(tokens[i], data);
				}
				return sum / token_count;
			};
		}
	};

	/**
	 * Returns a function that can be used to compare two
	 * results, for sorting purposes. If no sorting should
	 * be performed, `null` will be returned.
	 *
	 * @param {string|object} search
	 * @param {object} options
	 * @return function(a,b)
	 */
	Sifter.prototype.getSortFunction = function(search, options) {
		var i, n, self, field, fields, fields_count, multiplier, multipliers, get_field, implicit_score, sort;

		self   = this;
		search = self.prepareSearch(search, options);
		sort   = (!search.query && options.sort_empty) || options.sort;

		/**
		 * Fetches the specified sort field value
		 * from a search result item.
		 *
		 * @param  {string} name
		 * @param  {object} result
		 * @return {mixed}
		 */
		get_field = function(name, result) {
			if (name === '$score') { return result.score; }
			return getattr(self.items[result.id], name, options.nesting);
		};

		// parse options
		fields = [];
		if (sort) {
			for (i = 0, n = sort.length; i < n; i++) {
				if (search.query || sort[i].field !== '$score') {
					fields.push(sort[i]);
				}
			}
		}

		// the "$score" field is implied to be the primary
		// sort field, unless it's manually specified
		if (search.query) {
			implicit_score = true;
			for (i = 0, n = fields.length; i < n; i++) {
				if (fields[i].field === '$score') {
					implicit_score = false;
					break;
				}
			}
			if (implicit_score) {
				fields.unshift({field: '$score', direction: 'desc'});
			}
		} else {
			for (i = 0, n = fields.length; i < n; i++) {
				if (fields[i].field === '$score') {
					fields.splice(i, 1);
					break;
				}
			}
		}

		multipliers = [];
		for (i = 0, n = fields.length; i < n; i++) {
			multipliers.push(fields[i].direction === 'desc' ? -1 : 1);
		}

		// build function
		fields_count = fields.length;
		if (!fields_count) {
			return null;
		} else if (fields_count === 1) {
			field = fields[0].field;
			multiplier = multipliers[0];
			return function(a, b) {
				return multiplier * cmp(
					get_field(field, a),
					get_field(field, b)
				);
			};
		} else {
			return function(a, b) {
				var i, result, a_value, b_value, field;
				for (i = 0; i < fields_count; i++) {
					field = fields[i].field;
					result = multipliers[i] * cmp(
						get_field(field, a),
						get_field(field, b)
					);
					if (result) { return result; }
				}
				return 0;
			};
		}
	};

	/**
	 * Parses a search query and returns an object
	 * with tokens and fields ready to be populated
	 * with results.
	 *
	 * @param {string} query
	 * @param {object} options
	 * @returns {object}
	 */
	Sifter.prototype.prepareSearch = function(query, options) {
		if (typeof query === 'object') { return query; }

		options = extend({}, options);

		var option_fields     = options.fields;
		var option_sort       = options.sort;
		var option_sort_empty = options.sort_empty;

		if (option_fields && !is_array(option_fields)) { options.fields = [option_fields]; }
		if (option_sort && !is_array(option_sort)) { options.sort = [option_sort]; }
		if (option_sort_empty && !is_array(option_sort_empty)) { options.sort_empty = [option_sort_empty]; }

		return {
			options : options,
			query   : String(query || '').toLowerCase(),
			tokens  : this.tokenize(query),
			total   : 0,
			items   : []
		};
	};

	/**
	 * Searches through all items and returns a sorted array of matches.
	 *
	 * The `options` parameter can contain:
	 *
	 *   - fields {string|array}
	 *   - sort {array}
	 *   - score {function}
	 *   - filter {bool}
	 *   - limit {integer}
	 *
	 * Returns an object containing:
	 *
	 *   - options {object}
	 *   - query {string}
	 *   - tokens {array}
	 *   - total {int}
	 *   - items {array}
	 *
	 * @param {string} query
	 * @param {object} options
	 * @returns {object}
	 */
	Sifter.prototype.search = function(query, options) {
		var self = this, value, score, search, calculateScore;
		var fn_sort;
		var fn_score;

		search  = this.prepareSearch(query, options);
		options = search.options;
		query   = search.query;

		// generate result scoring function
		fn_score = options.score || self.getScoreFunction(search);

		// perform search and sort
		if (query.length) {
			self.iterator(self.items, function(item, id) {
				score = fn_score(item);
				if (options.filter === false || score > 0) {
					search.items.push({'score': score, 'id': id});
				}
			});
		} else {
			self.iterator(self.items, function(item, id) {
				search.items.push({'score': 1, 'id': id});
			});
		}

		fn_sort = self.getSortFunction(search, options);
		if (fn_sort) { search.items.sort(fn_sort); }

		// apply limits
		search.total = search.items.length;
		if (typeof options.limit === 'number') {
			search.items = search.items.slice(0, options.limit);
		}

		return search;
	};

	// utilities
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	var cmp = function(a, b) {
		if (typeof a === 'number' && typeof b === 'number') {
			return a > b ? 1 : (a < b ? -1 : 0);
		}
		a = asciifold(String(a || ''));
		b = asciifold(String(b || ''));
		if (a > b) { return 1; }
		if (b > a) { return -1; }
		return 0;
	};

	var extend = function(a, b) {
		var arguments$1 = arguments;

		var i, n, k, object;
		for (i = 1, n = arguments.length; i < n; i++) {
			object = arguments$1[i];
			if (!object) { continue; }
			for (k in object) {
				if (object.hasOwnProperty(k)) {
					a[k] = object[k];
				}
			}
		}
		return a;
	};

	/**
	 * A property getter resolving dot-notation
	 * @param  {Object}  obj     The root object to fetch property on
	 * @param  {String}  name    The optionally dotted property name to fetch
	 * @param  {Boolean} nesting Handle nesting or not
	 * @return {Object}          The resolved property value
	 */
	var getattr = function(obj, name, nesting) {
	    if (!obj || !name) { return; }
	    if (!nesting) { return obj[name]; }
	    var names = name.split(".");
	    while(names.length && (obj = obj[names.shift()])){  }
	    return obj;
	};

	var trim = function(str) {
		return (str + '').replace(/^\s+|\s+$|/g, '');
	};

	var escape_regex = function(str) {
		return (str + '').replace(/([.?*+^$[\]\\(){}|-])/g, '\\$1');
	};

	var is_array = Array.isArray || (typeof $ !== 'undefined' && $.isArray) || function(object) {
		return Object.prototype.toString.call(object) === '[object Array]';
	};

	var DIACRITICS = {
		'a': '[aḀḁĂăÂâǍǎȺⱥȦȧẠạÄäÀàÁáĀāÃãÅåąĄÃąĄ]',
		'b': '[b␢βΒB฿𐌁ᛒ]',
		'c': '[cĆćĈĉČčĊċC̄c̄ÇçḈḉȻȼƇƈɕᴄＣｃ]',
		'd': '[dĎďḊḋḐḑḌḍḒḓḎḏĐđD̦d̦ƉɖƊɗƋƌᵭᶁᶑȡᴅＤｄð]',
		'e': '[eÉéÈèÊêḘḙĚěĔĕẼẽḚḛẺẻĖėËëĒēȨȩĘęᶒɆɇȄȅẾếỀềỄễỂểḜḝḖḗḔḕȆȇẸẹỆệⱸᴇＥｅɘǝƏƐε]',
		'f': '[fƑƒḞḟ]',
		'g': '[gɢ₲ǤǥĜĝĞğĢģƓɠĠġ]',
		'h': '[hĤĥĦħḨḩẖẖḤḥḢḣɦʰǶƕ]',
		'i': '[iÍíÌìĬĭÎîǏǐÏïḮḯĨĩĮįĪīỈỉȈȉȊȋỊịḬḭƗɨɨ̆ᵻᶖİiIıɪＩｉ]',
		'j': '[jȷĴĵɈɉʝɟʲ]',
		'k': '[kƘƙꝀꝁḰḱǨǩḲḳḴḵκϰ₭]',
		'l': '[lŁłĽľĻļĹĺḶḷḸḹḼḽḺḻĿŀȽƚⱠⱡⱢɫɬᶅɭȴʟＬｌ]',
		'n': '[nŃńǸǹŇňÑñṄṅŅņṆṇṊṋṈṉN̈n̈ƝɲȠƞᵰᶇɳȵɴＮｎŊŋ]',
		'o': '[oØøÖöÓóÒòÔôǑǒŐőŎŏȮȯỌọƟɵƠơỎỏŌōÕõǪǫȌȍՕօ]',
		'p': '[pṔṕṖṗⱣᵽƤƥᵱ]',
		'q': '[qꝖꝗʠɊɋꝘꝙq̃]',
		'r': '[rŔŕɌɍŘřŖŗṘṙȐȑȒȓṚṛⱤɽ]',
		's': '[sŚśṠṡṢṣꞨꞩŜŝŠšŞşȘșS̈s̈]',
		't': '[tŤťṪṫŢţṬṭƮʈȚțṰṱṮṯƬƭ]',
		'u': '[uŬŭɄʉỤụÜüÚúÙùÛûǓǔŰűŬŭƯưỦủŪūŨũŲųȔȕ∪]',
		'v': '[vṼṽṾṿƲʋꝞꝟⱱʋ]',
		'w': '[wẂẃẀẁŴŵẄẅẆẇẈẉ]',
		'x': '[xẌẍẊẋχ]',
		'y': '[yÝýỲỳŶŷŸÿỸỹẎẏỴỵɎɏƳƴ]',
		'z': '[zŹźẐẑŽžŻżẒẓẔẕƵƶ]'
	};

	var asciifold = (function() {
		var i, n, k, chunk;
		var foreignletters = '';
		var lookup = {};
		for (k in DIACRITICS) {
			if (DIACRITICS.hasOwnProperty(k)) {
				chunk = DIACRITICS[k].substring(2, DIACRITICS[k].length - 1);
				foreignletters += chunk;
				for (i = 0, n = chunk.length; i < n; i++) {
					lookup[chunk.charAt(i)] = k;
				}
			}
		}
		var regexp = new RegExp('[' +  foreignletters + ']', 'g');
		return function(str) {
			return str.replace(regexp, function(foreignletter) {
				return lookup[foreignletter];
			}).toLowerCase();
		};
	})();


	// export
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	return Sifter;
}));
});

var Vue$1 = vue;
Vue$1 = 'default' in Vue$1 ? Vue$1['default'] : Vue$1;

var version = '2.1.0';

var compatible = (/^2\./).test(Vue$1.version);
if (!compatible) {
  Vue$1.util.warn('VueClickaway ' + version + ' only supports Vue 2.x, and does not support Vue ' + Vue$1.version);
}



// @SECTION: implementation

var HANDLER = '_vue_clickaway_handler';

function bind(el, binding) {
  unbind(el);

  var callback = binding.value;
  if (typeof callback !== 'function') {
    if (process.env.NODE_ENV !== 'production') {
      Vue$1.util.warn(
        'v-' + binding.name + '="' +
        binding.expression + '" expects a function value, ' +
        'got ' + callback
      );
    }
    return;
  }

  // @NOTE: Vue binds directives in microtasks, while UI events are dispatched
  //        in macrotasks. This causes the listener to be set up before
  //        the "origin" click event (the event that lead to the binding of
  //        the directive) arrives at the document root. To work around that,
  //        we ignore events until the end of the "initial" macrotask.
  // @REFERENCE: https://jakearchibald.com/2015/tasks-microtasks-queues-and-schedules/
  // @REFERENCE: https://github.com/simplesmiler/vue-clickaway/issues/8
  var initialMacrotaskEnded = false;
  setTimeout(function() {
    initialMacrotaskEnded = true;
  }, 0);

  el[HANDLER] = function(ev) {
    // @NOTE: IE 5.0+
    // @REFERENCE: https://developer.mozilla.org/en/docs/Web/API/Node/contains
    if (initialMacrotaskEnded && !el.contains(ev.target)) {
      return callback(ev);
    }
  };

  document.documentElement.addEventListener('click', el[HANDLER], false);
}

function unbind(el) {
  document.documentElement.removeEventListener('click', el[HANDLER], false);
  delete el[HANDLER];
}

var directive = {
  bind: bind,
  update: function(el, binding) {
    if (binding.value === binding.oldValue) { return; }
    bind(el, binding);
  },
  unbind: unbind,
};

var directive_1 = directive;

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;
var nativeMin = Math.min;

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function() {
  return root.Date.now();
};

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;

    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        result = wait - timeSinceLastCall;

    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
  }

  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }

  function debounced() {
    var time = now(),
        isInvoking = shouldInvoke(time);

    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

var index$1 = debounce;

function isArray (any) {
  return Array.isArray(any)
}

function isObject$1 (any) {
  return any !== null && typeof (any) === 'object'
}

function mapObject (source, take) {
  var target = {};

  if (isArray(take)) {
    take.forEach(function (key) {
      if (key in source) {
        target[key] = source[key];
      }
    });
  } else {
    Object.keys(take).forEach(function (sourceKey) {
      var targetKey = take[sourceKey];

      if (sourceKey in source) {
        target[targetKey] = source[sourceKey];
      }
    });
  }

  return target
}

function each (obj, callback) {
  Object.keys(obj).forEach(function (key) { return callback(obj[key], key); });
}

var ErrorBag = function ErrorBag (errors) {
  this._errors = typeof (errors) === 'object' ? errors : {};
};

ErrorBag.prototype.has = function has (key) {
  return this._errors.hasOwnProperty(key)
};

ErrorBag.prototype.get = function get (key) {
  var value = this._errors[key];

  if (isArray(value)) {
    return value.join(' ')
  }

  return value
};

ErrorBag.prototype.unset = function unset (key) {
  delete this._errors[key];
};

var TypeaheadField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('dropdown',_vm._b({directives:[{name:"on-click-away",rawName:"v-on-click-away",value:(_vm.close),expression:"close"}],staticClass:"bootstrap-for-vue-typeahead",on:{"select":_vm.onItemSelected}},'dropdown',{ items: _vm.items, show: _vm.show, component: _vm.component, itemKey: _vm.suggestionValue, active: _vm.index, selected: _vm.selected }),[_c('search-field',_vm._b({directives:[{name:"model",rawName:"v-model",value:(_vm.query),expression:"query"}],ref:"search",class:[_vm.inputClass],domProps:{"value":(_vm.query)},on:{"input":[function($event){_vm.query=$event;},function (val) { return _vm.$emit('search', val); }],"keydown":[function($event){if(_vm._k($event.keyCode,"down",40)){ return; }_vm.onDown($event);},function($event){if(_vm._k($event.keyCode,"up",38)){ return; }_vm.onUp($event);},function($event){if(_vm._k($event.keyCode,"enter",13)){ return; }$event.preventDefault();_vm.onEnter($event);},function($event){if(_vm._k($event.keyCode,"tab",9)){ return; }_vm.onTab($event);}],"focus":function($event){_vm.show = true;},"blur":_vm.onBlur}},'search-field',{ placeholder: _vm.placeholder, suggestion: _vm.suggestion, icon: _vm.icon, name: _vm.name, autocomplete: _vm.autocomplete, autofocus: _vm.autofocus }),[_vm._t("default")],2),(_vm.showEmpty)?_c('div',{staticClass:"px-3 text-muted",slot:"empty"},[_vm._v("No results :(")]):_vm._e()],1)},staticRenderFns: [],
  props: Object.assign({}, {value: {
      type: [Array, String, Number],
      required: true
    },

    suggestions: {
      type: Array,
      required: true
    },

    inputClass: String,

    suggestionValue: {
      type: String,
      default: 'name'
    },

    search: {
      type: [Object, Array]
    },

    filter: {
      type: Function,
      default: function () { return true; }
    },

    component: {
      type: String
    },

    showEmpty: {
      type: Boolean,
      default: true
    },

    name: String},

    mapObject(SearchField.props, ['placeholder', 'icon', 'autofocus', 'autocomplete'])),

  data: function data () {
    return {
      show: false,
      q: '',
      index: -1,
      skip: false
    }
  },

  computed: {
    query: {
      get: function get () {
        var show = this.show;
        var value = this.value instanceof Array ? this.value : [this.value];
        var suggestionValue = this.suggestionValue;
        var q = this.q;

        if (show) { return q }

        return value.map(function (v) { return v[suggestionValue]; }).join(', ')
      },

      set: function set (val) {
        this.q = val;
      }
    },

    indexed: function indexed () {
      return new sifter(this.suggestions)
    },

    selected: function selected () {
      var value = this.value;

      if (value instanceof Array) { return value }

      return [value]
    },

    config: function config () {
      var search = this.search;
      var displayField = this.suggestionValue;

      var config = {
        fields: [displayField],
        sort: [{ field: displayField, direction: 'asc' }],
        limit: 25
      };

      if (isArray(search)) {
        config.fields = search;

        return config
      }

      if (isObject$1(search)) {
        return Object.assign({}, config, search)
      }

      return config
    },

    items: function items () {
      var this$1 = this;

      var indexed = this.indexed;
      var config = this.config;
      var value = this.q;

      var results = indexed.search(value, config);

      return results.items.map(function (ref) {
        var id = ref.id;

        return this$1.suggestions[id];
      }).filter(this.filter)
    },

    suggestionItem: function suggestionItem () {
      var suggestions = this.items;
      var value = this.q;
      var key = this.suggestionValue;

      var suggestion = suggestions.find(function (suggestion) { return typeof (suggestion[key]) === 'string' && suggestion[key].startsWith(value); });

      if (suggestion) { return suggestion }

      return null
    },

    suggestion: function suggestion () {
      var item = this.suggestionItem;
      var key = this.suggestionValue;

      if (item) { return item[key] }

      return ''
    }
  },

  methods: {
    onItemSelected: function onItemSelected (item) {
      var this$1 = this;

      this.$el.querySelector('input[type=search]').focus();

      this.$nextTick(function () {
        console.log('BLUR IT');
        this$1.blur();
      });

      this.$emit('select', item);
    },

    onDown: function onDown () {
      if (this.index + 1 < this.items.length) {
        this.index += 1;
      } else {
        this.index = 0;
      }

      this.scrollIntoView();
    },

    onUp: function onUp () {
      if (this.index > 0) { this.index -= 1; }
      else { this.index = this.items.length - 1; }

      this.scrollIntoView();
    },

    onEnter: function onEnter () {
      if (this.index > -1) {
        this.$emit('select', this.items[this.index]);
        this.blur();
      } else if (this.suggestionItem) {
        this.$emit('select', this.suggestionItem);
        this.blur();
      } else {
        this.$emit('enter');
      }
    },

    onTab: function onTab (e) {
      if (e.shiftKey || e.altKey) { return }

      if (this.q.length && this.q !== this.suggestion) {
        this.q = this.suggestion;

        e.preventDefault();
      }

      if (this.items.length >= 1 && this.q.length && this.q === this.suggestion) {
        this.$emit('select', this.items[0]);
      }
    },

    onBlur: index$1(function onBlur() {
      if (this.skip) {
        this.skip = false;

        return
      }

      this.close();
      this.$emit('blur');
    }, 400),

    blur: function blur () {
      this.$el.querySelector('input[type=search]').blur();
    },

    close: function close () {
      this.show = false;
      this.index = -1;
      this.q = '';
    },

    scrollIntoView: function scrollIntoView () {
      var this$1 = this;

      this.$nextTick(function () {
        var el = this$1.$el.querySelector('.dropdown-menu .active');

        if (!el) { return }

        if (el.scrollIntoViewIfNeeded) {
          el.scrollIntoViewIfNeeded();
        } else if (el.scrollIntoView) {
          el.scrollIntoView();
        }
      });
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('keep-open', function () {
      this$1.skip = true;
      this$1.$el.querySelector('input[type=search]').focus();
    });
  },

  components: { Dropdown: Dropdown, SearchField: SearchField },

  directives: { onClickAway: directive_1 }
};

var CheckboxWrapper = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('fieldset',{staticClass:"form-group"},[(_vm.title)?_c('legend',{staticClass:"bootstrap-for-vue-CheckboxWrapper-wrapper-legend"},[_vm._v(_vm._s(_vm.title))]):_vm._e(),_vm._t("default")],2)},staticRenderFns: [],cssModules: {"wrapperLegend":"bootstrap-for-vue-CheckboxWrapper-wrapper-legend","wrapper-legend":"bootstrap-for-vue-CheckboxWrapper-wrapper-legend"},
  name: 'CheckboxWrapper',

  props: {
    title: {
      type: String,
      default: null
    }
  }
};

var SmartForm = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('form',{on:{"submit":function($event){$event.preventDefault();(function(any) { return _vm.$emit('submit'); });}}},[_c('input',{attrs:{"type":"submit","hidden":""}}),(_vm.form && _vm.form.status)?_c('alert',{class:_vm.alertClass,attrs:{"type":"danger"},domProps:{"innerHTML":_vm._s(_vm.form.status)}}):_vm._e(),_vm._t("default")],2)},staticRenderFns: [],
  name: 'SmartForm',

  inject: ['form'],

  props: {
    alertClass: {
      type: String,
      default: 'mb-3'
    }
  }

};

var inputHelper = {
  inject: ['form'],

  props: {
    value: { required: true },
    title: { type: String, default: null },
    subtitle: { type: String, default: null },
    name: { type: String, default: null },
    inputName: { type: String, default: null },
    errors: {
      validator: function validator (errors) {
        return !errors || errors instanceof ErrorBag
      },

      default: null
    },
    inputClass: String,
    placeholder: String,
    autofill: [String, Boolean],
    autocomplete: [String, Boolean],
    autofocus: [Boolean],
    min: {},
    max: {}
  },

  data: function () { return ({
    expression: null,
    required: null
  }); },

  computed: {

    id: function id () {
      return ("text" + (this._uid))
    },

    nameKey: function nameKey () {
      var inputName = this.inputName;
      var expression = this.expression;

      if (inputName) { return inputName }

      return expression
    },

    feedback: function feedback () {
      var errors = this.errors;
      var form = this.form;
      var name = this.nameKey;

      if (errors) {
        return errors.get(name)
      }

      if (form && form.errors) {
        return form.errors.get(name)
      }

      return null
    }
  },

  methods: {
    /**
     * Mirror attributes from root element.
     *
     * @return {void}
     */
    updateAttributes: function updateAttributes () {
      if (!this.$vnode || !this.$vnode.data || !this.$vnode.data.attrs) { return }

      this.required = this.$vnode.data.attrs.hasOwnProperty('required');
    }
  },

  mounted: function mounted () {
    var this$1 = this;

    var model = this.$vnode.data.model;

    if (model) {
      this.expression = model.expression.split('.').pop();
    }

    this.updateAttributes();

    if (this.autofocus !== false) {
      this.$nextTick(function () {
        var el = this$1.$el.querySelector('[autofocus]');
        if (el) { el.focus(); }
      });
    }
  },

  beforeUpdate: function beforeUpdate () {
    this.updateAttributes();
  }
};

var checkbox = {
  name: 'InputBox',

  props: {
    value: {
      type: [Array, String, Number, Boolean],
      required: true
    },

    radio: {
      default: undefined
    },

    checkbox: {
      default: true
    },

    inline: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    /**
     * Type of field (radio/checkbox)
     *
     * @type {String}
     */
    type: function type () {
      var radio = this.radio;

      if (radio !== undefined) { return 'radio' }

      return 'checkbox'
    },

    /**
     * Value of the checkbox (If checked, value of the model would be set to this).
     *
     * @type {number|string|bool}
     */
    localValue: function localValue () {
      var radio = this.radio;
      var checkbox = this.checkbox;

      if (radio !== undefined) { return radio }

      return checkbox
    },

    /**
     * Current state of the box/radio.
     *
     * @type {bool}
     */
    state: function state () {
      var value = this.value;
      var localValue = this.localValue;

      if (isArray(value)) {
        return value.indexOf(localValue) > -1
      }

      return value === localValue
    }
  },

  methods: {
    /**
     * Handle check/uncheck event.
     *
     * @return {void}
     */
    onChange: function onChange () {
      if (this.state) {
        this.uncheck();
      } else {
        this.check();
      }
    },

    /**
     * Mark box/radio as checked.
     *
     * @return {void}
     */
    check: function check () {
      if (this.type === 'checkbox' && isArray(this.value)) {
        var value = this.value.slice(0); // Copy Array.

        value.push(this.localValue);
        this.$emit('input', value);

        return
      }

      this.$emit('input', this.localValue);
    },

    /**
     * Mark box/radio as unchecked.
     */
    uncheck: function uncheck () {
      if (this.type === 'radio') { return }

      if (this.value instanceof Array) {
        var value = this.value.slice(0);

        value.splice(value.indexOf(this.localValue), 1);
        this.$emit('input', value);

        return
      }

      if (this.localValue === true) {
        this.$emit('input', false);

        return
      }

      this.$emit('input', null);
    }
  },

  mixins: [inputHelper]
};

var CustomBox = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-check bootstrap-for-vue-CustomBox-checkbox",class:{ 'has-danger': _vm.feedback, 'form-check-inline': _vm.inline },attrs:{"checked":_vm.state}},[_c('label',{staticClass:"bootstrap-for-vue-CustomBox-indicator"},[_c('input',_vm._b({staticClass:"bootstrap-for-vue-CustomBox-custom-control-input",domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.name || _vm.id, autofocus: _vm.autofocus, autocomplete: _vm.autocomplete })),_vm._v(" "),(_vm.title)?_c('span',[_vm._v(_vm._s(_vm.title || ' '))]):_vm._e()])])},staticRenderFns: [],cssModules: {"checkbox":"bootstrap-for-vue-CustomBox-checkbox","indicator":"bootstrap-for-vue-CustomBox-indicator","customControlInput":"bootstrap-for-vue-CustomBox-custom-control-input","custom-control-input":"bootstrap-for-vue-CustomBox-custom-control-input"},
  mixins: [checkbox]
};

var BootstrapBox = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-check",class:{ 'has-danger': _vm.feedback, 'form-check-inline': _vm.inline }},[_c('label',{staticClass:"custom-control",class:[("custom-" + (_vm.type))]},[_c('input',_vm._b({staticClass:"custom-control-input",attrs:{"hidden":""},domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.name || _vm.id, autofocus: _vm.autofocus, autocomplete: _vm.autocomplete })),_vm._v(" "),_c('span',{staticClass:"custom-control-indicator"}),_vm._v(" "),(_vm.title)?_c('span',{staticClass:"custom-control-description"},[_vm._v(_vm._s(_vm.title))]):_vm._e()])])},staticRenderFns: [],
  mixins: [checkbox]
};

var InputBox = {
  functional: true,

  render: function render (h, ref) {
    var props = ref.props;
    var data = ref.data;
    var children = ref.children;

    if (props.custom) { return h(CustomBox, data, children) }

    return h(BootstrapBox, data, children)
  },

  props: {
    custom: {
      type: Boolean,
      default: false
    }
  }
};

var InputButton = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('button',{staticClass:"btn",class:[_vm.styles],attrs:{"type":_vm.type,"role":"button"}},[(_vm.icon)?_c('icon',{staticClass:"mr-2",attrs:{"type":_vm.icon}}):_vm._e(),_vm._t("default",[_vm._v(_vm._s(_vm.value))])],2)},staticRenderFns: [],
  name: 'InputButton',

  props: {
    icon: {
      type: String,
      default: null
    },

    theme: {
      type: String,
      default: 'primary'
    },

    type: {
      type: String,
      default: 'button'
    },

    value: {
      type: String,
      default: null
    }
  },

  computed: {
    styles: function styles () {
      return [("btn-" + (this.theme))]
    }
  },

  components: { Icon: Icon }
};

var InputSearch = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('search-field',_vm._b({staticClass:"form-control",class:[_vm.inputClass],attrs:{"id":_vm.id},on:{"input":function (val) { return _vm.$emit('input', val); }}},'search-field',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, suggestion: _vm.suggestion, name: _vm.name, autocomplete: _vm.autocomplete })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputSearch',

  props: {
    suggestion: {
      type: String
    }
  },

  components: { SearchField: SearchField },
  mixins: [inputHelper]
};

var InputSelect = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('select',_vm._b({staticClass:"form-control custom-select",class:[_vm.inputClass],on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'select',{ id: _vm.id, value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, multiple: _vm.multiple, name: _vm.name }),[(_vm.placeholder)?_c('option',{attrs:{"disabled":"disabled"},domProps:{"selected":_vm.value === '' || _vm.value === null}},[_vm._v(_vm._s(_vm.placeholder))]):_vm._e(),_vm._l((_vm.selectOptions),function(option){return _c('option',{attrs:{"disabled":_vm.getDisabled(option)},domProps:{"value":_vm.getValue(option)}},[_vm._v(_vm._s(_vm.getDisplay(option)))])})],2),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputSelect',

  props: {
    options: {
      type: [Array, Object],
      required: true
    },
    multiple: {
      type: [Boolean, Number],
      default: false
    },
    valueKey: {
      type: String,
      default: 'id'
    },
    displayKey: {
      type: String,
      default: 'name'
    },
    disabledKey: {
      type: String,
      default: 'disabled'
    }
  },

  computed: {
    selectOptions: function selectOptions () {
      var this$1 = this;

      var options = this.options;

      if (isArray(options)) {
        return options
      }

      return Object.keys(options).map(function (id) {
        var option = (isObject$1(options[id]) ? options[id] : ( obj = {}, obj[this$1.displayKey] = options[id], obj ));
        var obj;

        option[this$1.valueKey] = id;

        return option
      })
    }
  },

  methods: {

    getValue: function getValue (option) {
      return option[this.valueKey]
    },

    getDisplay: function getDisplay (option) {
      return option[this.displayKey]
    },

    getDisabled: function getDisabled (option) {
      return this.disabledKey.charAt(0) === '!' ? !option[this.disabledKey.substring(1)] : option[this.disabledKey]
    }

  },

  mixins: [inputHelper]
};

var InputSwitch = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('label',{staticClass:"form-check switch round",class:{ 'has-danger': _vm.feedback, 'form-check-inline': _vm.inline },attrs:{"checked":_vm.state}},[_c('input',_vm._b({staticClass:"custom-control-input",domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.name || _vm.id, autofocus: _vm.autofocus, autocomplete: _vm.autocomplete })),_vm._v(" "),_c('span',{staticClass:"slider"}),_vm._v(" "+_vm._s(_vm.title))])},staticRenderFns: [],
  name: 'InputSwitch',

  mixins: [checkbox]
};

var InputText = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('input',_vm._b({staticClass:"form-control",class:[_vm.inputClass],attrs:{"id":_vm.id},on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'input',{ type: _vm.type, value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, autocomplete: _vm.autocomplete, min: _vm.min, max: _vm.max, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputText',

  props: {
    type: {
      type: String,
      default: 'text'
    }
  },

  mixins: [inputHelper]
};

var InputTextarea = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('textarea',_vm._b({staticClass:"form-control",class:[ _vm.resizableClass, _vm.inputClass ],attrs:{"id":_vm.id,"type":"text"},on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'textarea',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, autocomplete: _vm.autocomplete, rows: _vm.rows, cols: _vm.cols, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputTextarea',

  props: {
    resizeable: {
      type: [String, Boolean],
      default: ''
    },
    rows: {
      type: Number,
      default: 5
    },
    cols: {
      type: Number,
      default: null
    }
  },

  computed: {
    resizableClass: function resizableClass () {
      var resize = this.resizeable;

      if (resize === true) { return 'resizable' }
      if (resize === false) { return 'resizable-none' }
      if (!resize) { return '' }
      return ("resizable-" + resize)
    }
  },

  mixins: [inputHelper]
};

var InputTypeahead = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('typeahead-field',_vm._b({directives:[{name:"model",rawName:"v-model",value:(_vm.selected),expression:"selected"}],ref:"ta",attrs:{"id":_vm.id},domProps:{"value":(_vm.selected)},on:{"select":_vm.onInput,"search":function (any) { return _vm.$emit('search', any); },"enter":function (any) { return _vm.$emit('enter', any); },"blur":function (any) { return _vm.$emit('blur', any); },"input":function($event){_vm.selected=$event;}}},'typeahead-field',{ required: _vm.required, autofocus: _vm.autofocus, suggestions: _vm.suggestions, suggestionKey: _vm.suggestionKey, search: _vm.search, filter: _vm.filter, component: _vm.component, showEmpty: _vm.showEmpty, inputClass: _vm.inputClass, placeholder: _vm.placeholder, icon: false, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputTypeahead',

  props: Object.assign({}, {suggestionKey: {
      type: String,
      default: 'id'
    },

    placeholder: {
      type: String,
      default: ''
    }},

    mapObject(TypeaheadField.props, [
      'suggestions', 'suggestionValue', 'search', 'filter', 'component', 'showEmpty'
    ])),

  computed: {
    selected: function selected () {
      var items = this.suggestions;
      var key = this.suggestionKey;
      var value = this.value instanceof Array ? this.value : [this.value];

      return items.filter(function (item) { return value.indexOf(item[key]) > -1; })
    }
  },

  methods: {
    onInput: function onInput (item) {
      var id = item[this.suggestionKey];

      if (this.value instanceof Array) {
        var index = this.value.indexOf(id);
        var value = this.value.slice();

        if (index > -1) {
          value.splice(index, 1);
        } else {
          value.push(id);
        }

        this.$emit('input', value);
        this.$refs.ta.$emit('keep-open');
      } else {
        this.$emit('input', id);
      }
    }
  },

  components: { TypeaheadField: TypeaheadField },
  mixins: [inputHelper]
};

// Breaks specs.



var components = Object.freeze({
	Alert: Alert,
	Breadcrumb: Breadcrumb,
	Dropdown: Dropdown,
	Icon: Icon,
	Modal: Modal,
	Search: SearchField,
	Typeahead: TypeaheadField,
	CheckboxWrapper: CheckboxWrapper,
	SmartForm: SmartForm,
	InputBox: InputBox,
	InputButton: InputButton,
	InputSearch: InputSearch,
	InputSelect: InputSelect,
	InputSwitch: InputSwitch,
	InputText: InputText,
	InputTextarea: InputTextarea,
	InputTypeahead: InputTypeahead
});

var version$1 = "0.3.3";

var formHelper = {

  provide: function provide () {
    var this$1 = this;

    var form = {};

    Object.defineProperties(form, {
      status: {
        enumerable: true,
        get: function () { return this$1.$data._formStatus; }
      },

      errors: {
        enumerable: true,
        get: function () { return this$1.$data._formErrors; }
      }
    });

    return { form: form }
  },

  data: function () { return ({ _formErrors: null, _formStatus: null }); },

  methods: {

    /**
     * @deprecated
     */
    setErrors: function setErrors (payload) {
      return this.setFormErrors(payload)
    },

    /**
     * @deprecated
     */
    clearError: function clearError (key) {
      return this.clearFormErrors(key)
    },

    setFormErrors: function setFormErrors (payload) {
      this.clearFormErrors();

      if (!isObject$1(payload)) { return }

      this.$data._formErrors = new ErrorBag(payload);
      if ('$message' in payload) {
        this.$data._formStatus = payload.$message;
      }
    },

    setFormStatus: function setFormStatus (status) {
      this.$data._formStatus = status;
    },

    clearFormErrors: function clearFormErrors (key) {
      if (key !== undefined) {
        this.$data._formErrors.unset(key);
      } else {
        this.$data._formErrors = new ErrorBag({});
        this.$data._formStatus = null;
      }
    }

  },

  created: function created () {
    this.$data._formErrors = new ErrorBag({});
  }
};

var plugin = {
  version: version$1,
  install: function install (Vue, options) {
    if ( options === void 0 ) options = {};

    if (options.custom === true) {
      Modal.props.custom.default = true;
      InputBox.props.custom.default = true;
    }

    each(components, function (component, name$$1) {
      if (options.all || name$$1.startsWith('Input') || name$$1 === 'CheckboxWrapper') {
        Vue.component(name$$1, component);
      }
    });
    each(directives, function (directive, name$$1) { return Vue.directive(name$$1, directive); });
  }
};

// Install by default if using the script tag
if (typeof window !== 'undefined' && 'Vue' in window) {
  Vue.use(plugin, window.bootstrapForVueConfig || {}); // eslint-disable-line no-undef
}

exports['default'] = plugin;
exports.formHelper = formHelper;
exports.ErrorBag = ErrorBag;

Object.defineProperty(exports, '__esModule', { value: true });

})));
